<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::acl::CurlMultiHandleWrapper Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.1.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>alexaClientSDK</b></li><li class="navelem"><b>acl</b></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html">CurlMultiHandleWrapper</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::acl::CurlMultiHandleWrapper Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_curl_multi_handle_wrapper_8h_source.html">CurlMultiHandleWrapper.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aaf31f1f1d0c33e7793b64ebb8ab24983"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#aaf31f1f1d0c33e7793b64ebb8ab24983">~CurlMultiHandleWrapper</a> ()</td></tr>
<tr class="separator:aaf31f1f1d0c33e7793b64ebb8ab24983"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f6523ca1adf98e30ce2f7adb5481bea"><td class="memItemLeft" align="right" valign="top">CURLM *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#a3f6523ca1adf98e30ce2f7adb5481bea">getCurlHandle</a> ()</td></tr>
<tr class="separator:a3f6523ca1adf98e30ce2f7adb5481bea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3a83c4944df886bb06e90d5d99c770c2"><td class="memItemLeft" align="right" valign="top">CURLMcode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#a3a83c4944df886bb06e90d5d99c770c2">addHandle</a> (CURL *handle)</td></tr>
<tr class="separator:a3a83c4944df886bb06e90d5d99c770c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27afe67ffe35bf05920587d5128d0819"><td class="memItemLeft" align="right" valign="top">CURLMcode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#a27afe67ffe35bf05920587d5128d0819">removeHandle</a> (CURL *handle)</td></tr>
<tr class="separator:a27afe67ffe35bf05920587d5128d0819"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b2fd846579c09c4cf03c041f3691de5"><td class="memItemLeft" align="right" valign="top">CURLMcode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#a1b2fd846579c09c4cf03c041f3691de5">perform</a> (int *runningHandles)</td></tr>
<tr class="separator:a1b2fd846579c09c4cf03c041f3691de5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5024e9d328f2b9c5cef6e38feb149dad"><td class="memItemLeft" align="right" valign="top">CURLMcode&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#a5024e9d328f2b9c5cef6e38feb149dad">wait</a> (std::chrono::milliseconds timeout, int *countHandlesUpdated)</td></tr>
<tr class="separator:a5024e9d328f2b9c5cef6e38feb149dad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2955d1240d125c9cdaffe3e52790493"><td class="memItemLeft" align="right" valign="top">CURLMsg *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#aa2955d1240d125c9cdaffe3e52790493">infoRead</a> (int *messagesInQueue)</td></tr>
<tr class="separator:aa2955d1240d125c9cdaffe3e52790493"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ae5c3dee58cec9726b9cb1a87bf2a6a4a"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html">CurlMultiHandleWrapper</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html#ae5c3dee58cec9726b9cb1a87bf2a6a4a">create</a> ()</td></tr>
<tr class="separator:ae5c3dee58cec9726b9cb1a87bf2a6a4a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class wraps a <code>libcurl</code> <code>multi</code> <code>handle</code> as a C++ object. Wrapping enables:</p><ul>
<li>tracking handles to ensure that all handles are removed before curl_multi_cleanup() is called.</li>
<li>centralized and consistent logging when curl_multi operations fail.</li>
<li>simplified signatures for calling code.</li>
<li>(slightly) improved type safety (so far just time values). </li>
</ul>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aaf31f1f1d0c33e7793b64ebb8ab24983"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf31f1f1d0c33e7793b64ebb8ab24983">&#9670;&nbsp;</a></span>~CurlMultiHandleWrapper()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::acl::CurlMultiHandleWrapper::~CurlMultiHandleWrapper </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a3a83c4944df886bb06e90d5d99c770c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3a83c4944df886bb06e90d5d99c770c2">&#9670;&nbsp;</a></span>addHandle()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CURLMcode alexaClientSDK::acl::CurlMultiHandleWrapper::addHandle </td>
          <td>(</td>
          <td class="paramtype">CURL *&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Add a <code>libcurl</code> <code>handle</code> to this instance.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">handle</td><td>The <code>libcurl</code> <code>handle</code> to add to this instance. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>libcurl</code> code indicating the result of this operation. </dd></dl>

</div>
</div>
<a id="ae5c3dee58cec9726b9cb1a87bf2a6a4a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae5c3dee58cec9726b9cb1a87bf2a6a4a">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html">CurlMultiHandleWrapper</a> &gt; alexaClientSDK::acl::CurlMultiHandleWrapper::create </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Create a <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html">CurlMultiHandleWrapper</a>.</p>
<dl class="section return"><dt>Returns</dt><dd>The new <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_curl_multi_handle_wrapper.html">CurlMultiHandleWrapper</a> instance, or nullptr if the operation fails. </dd></dl>

</div>
</div>
<a id="a3f6523ca1adf98e30ce2f7adb5481bea"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3f6523ca1adf98e30ce2f7adb5481bea">&#9670;&nbsp;</a></span>getCurlHandle()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CURLM * alexaClientSDK::acl::CurlMultiHandleWrapper::getCurlHandle </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get the <code>libcurl</code> <code>multi</code> <code>handle</code> underlying this instance.</p>
<dl class="section return"><dt>Returns</dt><dd>The <code>libcurl</code> <code>multi</code> <code>handle</code> underlying this instance. </dd></dl>

</div>
</div>
<a id="aa2955d1240d125c9cdaffe3e52790493"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa2955d1240d125c9cdaffe3e52790493">&#9670;&nbsp;</a></span>infoRead()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CURLMsg * alexaClientSDK::acl::CurlMultiHandleWrapper::infoRead </td>
          <td>(</td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>messagesInQueue</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Receive the next messages about the <code>libcurl</code> <code>handles</code> added to this <code>libcurl</code> <code>multi</code> <code>handle</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">messagesInQueue</td><td>The number of <code>libcurl</code> <code>handles</code> for which messages remain. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The next message or nullptr if there are no more messages. </dd></dl>

</div>
</div>
<a id="a1b2fd846579c09c4cf03c041f3691de5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1b2fd846579c09c4cf03c041f3691de5">&#9670;&nbsp;</a></span>perform()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CURLMcode alexaClientSDK::acl::CurlMultiHandleWrapper::perform </td>
          <td>(</td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>runningHandles</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Read and/or write available data for the <code>libcurl</code> <code>handles</code> added to this <code>libcurl</code> <code>multi</code> <code>handle</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">runningHandles</td><td>Returns the number of handles for which read/write operations were performed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>libcurl</code> code indicating the result of this operation. </dd></dl>

</div>
</div>
<a id="a27afe67ffe35bf05920587d5128d0819"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a27afe67ffe35bf05920587d5128d0819">&#9670;&nbsp;</a></span>removeHandle()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CURLMcode alexaClientSDK::acl::CurlMultiHandleWrapper::removeHandle </td>
          <td>(</td>
          <td class="paramtype">CURL *&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Remove a <code>libcurl</code> <code>handle</code> from this instance.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">handle</td><td>The <code>libcurl</code> <code>handle</code> to remove from this instance. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>libcurl</code> code indicating the result of this operation. </dd></dl>

</div>
</div>
<a id="a5024e9d328f2b9c5cef6e38feb149dad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5024e9d328f2b9c5cef6e38feb149dad">&#9670;&nbsp;</a></span>wait()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CURLMcode alexaClientSDK::acl::CurlMultiHandleWrapper::wait </td>
          <td>(</td>
          <td class="paramtype">std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>timeout</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>countHandlesUpdated</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Wait for actions to perform on the <code>libcurl</code> <code>handles</code> added to this <code>libcurl</code> <code>multi</code> <code>handle</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">timeout</td><td>How long to wait for actions to perform. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">countHandlesUpdated</td><td>The number of handles for which actions are ready to be performed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>libcurl</code> code indicating the result of this operation. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/Users/sdy/AVS_CPP_SDK/github/alexa-client-sdk/ACL/include/ACL/Transport/<a class="el" href="_curl_multi_handle_wrapper_8h_source.html">CurlMultiHandleWrapper.h</a></li>
<li>/Users/sdy/AVS_CPP_SDK/github/alexa-client-sdk/ACL/src/Transport/CurlMultiHandleWrapper.cpp</li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.1.0 - Copyright 2016-2017 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
